diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 5f0df95e3d0..4206012e58e 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -110,6 +110,14 @@ struct JoyDev {
         struct wine_input_absinfo       axes[ABS_MAX];
 
         WORD vendor_id, product_id, bus_type;
+
+    /* LUT for KEY_ to offset in rgbButtons */
+    int button_count;
+    BYTE buttons[KEY_MAX];
+    int dev_axes_to_di[ABS_MAX];
+
+    int axis_count;
+    int axes_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS * 2];
 };
 
 struct JoystickImpl
@@ -120,12 +128,8 @@ struct JoystickImpl
 	/* joystick private */
 	int				joyfd;
 
-	int                             dev_axes_to_di[ABS_MAX];
         POINTL                          povs[4];
 
-	/* LUT for KEY_ to offset in rgbButtons */
-	BYTE				buttons[KEY_MAX];
-
 	/* Force feedback variables */
 	int				ff_state;
 	int				ff_autocenter;
@@ -170,10 +174,12 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
         struct list *entry, IDirectInputEffect **out);
 
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    unix_joystick_get_mapping,
     unix_joystick_acquire,
     unix_joystick_unacquire,
     unix_joystick_ff_set_autocenter,
@@ -207,7 +213,7 @@ static struct JoyDev *joydevs = NULL;
 
 static void find_joydevs(void)
 {
-    int i;
+    int i, idx;
 
     if (InterlockedCompareExchange(&have_joydevs, 0, -1) != -1)
         /* Someone beat us to it */
@@ -344,6 +350,44 @@ static void find_joydevs(void)
 	    }
 	}
 
+        /* Count number of available axes - supported Axis & POVs */
+        for (i = 0, idx = 0; i < ABS_MAX; i++)
+        {
+            if (idx < WINE_JOYSTICK_MAX_AXES && i < ABS_HAT0X && test_bit(joydev.absbits, i))
+            {
+                joydev.dev_axes_to_di[i] = idx;
+                joydev.axis_count++;
+                /* If it's a wheel axis, remap to X/Y/Z */
+                if (i >= 8 && i <= 10) joydev.axes_map[idx] = i - 8;
+                else joydev.axes_map[idx] = i;
+                idx++;
+            }
+            else joydev.dev_axes_to_di[i] = -1;
+        }
+
+        for (i = 0; i < WINE_JOYSTICK_MAX_POVS; i++)
+        {
+            if (test_bit(joydev.absbits, ABS_HAT0X + i * 2) && test_bit(joydev.absbits, ABS_HAT0Y + i * 2))
+            {
+                joydev.axis_count += 2;
+                joydev.axes_map[idx] = joydev.axes_map[idx + 1] = WINE_JOYSTICK_MAX_AXES + i;
+                joydev.dev_axes_to_di[ABS_HAT0X + i * 2] = idx;
+                joydev.dev_axes_to_di[ABS_HAT0Y + i * 2] = idx + 1;
+                idx += 2;
+            }
+            else joydev.dev_axes_to_di[ABS_HAT0X + i * 2] = joydev.dev_axes_to_di[ABS_HAT0Y + i * 2] = -1;
+        }
+
+        /* Buttons can be anywhere, so check all */
+        joydev.button_count = 0;
+        memset(joydev.buttons, 0, sizeof(joydev.buttons));
+        for (i = 0; i < KEY_MAX && joydev.button_count < WINE_JOYSTICK_MAX_BUTTONS; i++)
+        {
+            if (!test_bit(joydev.keybits, i)) continue;
+            joydev.buttons[i] = 0x80 | joydev.button_count;
+            joydev.button_count++;
+        }
+
         if (ioctl(fd, EVIOCGID, &device_id) == -1)
         {
             WARN("ioctl(EVIOCGID) failed: %d %s\n", errno, strerror(errno));
@@ -508,14 +552,20 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
     return DI_OK;
 }
 
+static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    *axis_count = This->joydev->axis_count;
+    *axes_map = This->joydev->axes_map;
+}
+
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     LPDIDATAFORMAT df = NULL;
     HRESULT hr;
-    int i, idx = 0, default_axis_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS * 2];
+    int i, idx = 0;
 
-    This->generic.name = This->joydev->name;
     list_init(&This->generic.ff_effects);
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     This->ff_state = FF_STATUS_STOPPED;
@@ -533,40 +583,24 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     {
         if (idx < WINE_JOYSTICK_MAX_AXES && i < ABS_HAT0X && test_bit(This->joydev->absbits, i))
         {
-            This->generic.device_axis_count++;
-            This->dev_axes_to_di[i] = idx;
             This->generic.props[idx].lDevMin = This->joydev->axes[i].minimum;
             This->generic.props[idx].lDevMax = This->joydev->axes[i].maximum;
-            if (i >= 8 && i <= 10) /* If it's a wheel axis... */
-                default_axis_map[idx] = i - 8; /* ... remap to X/Y/Z */
-            else
-                default_axis_map[idx] = i;
             idx++;
         }
-        else This->dev_axes_to_di[i] = -1;
     }
 
     for (i = 0; i < WINE_JOYSTICK_MAX_POVS; i++)
     {
         if (test_bit(This->joydev->absbits, ABS_HAT0X + i * 2) && test_bit(This->joydev->absbits, ABS_HAT0Y + i * 2))
         {
-            This->generic.device_axis_count += 2;
             This->generic.props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
             This->generic.props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
-            This->dev_axes_to_di[ABS_HAT0X + i * 2] = idx;
             This->generic.props[idx + 1].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
             This->generic.props[idx + 1].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
-            This->dev_axes_to_di[ABS_HAT0Y + i * 2] = idx + 1;
-
-            default_axis_map[idx] = default_axis_map[idx + 1] = WINE_JOYSTICK_MAX_AXES + i;
             idx += 2;
         }
-        else This->dev_axes_to_di[ABS_HAT0X + i * 2] = This->dev_axes_to_di[ABS_HAT0Y + i * 2] = -1;
     }
 
-    /* do any user specified configuration */
-    if (FAILED(hr = setup_dinput_options(&This->generic, default_axis_map) != DI_OK)) goto failed;
-
     /* Create copy of default data format */
     hr = DIERR_OUTOFMEMORY;
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
@@ -577,7 +611,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     /* Construct internal data format */
 
     /* Supported Axis & POVs */
-    for (i = 0, idx = 0; i < This->generic.device_axis_count; i++)
+    for (i = 0, idx = 0; i < This->joydev->axis_count; i++)
     {
         int wine_obj = This->generic.axis_map[i];
 
@@ -603,17 +637,14 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
         idx++;
     }
 
-    /* Buttons can be anywhere, so check all */
-    for (i = 0; i < KEY_MAX && This->generic.devcaps.dwButtons < WINE_JOYSTICK_MAX_BUTTONS; i++)
+    for (i = 0; i < This->joydev->button_count; i++)
     {
-        if (!test_bit(This->joydev->keybits, i)) continue;
-
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[This->generic.devcaps.dwButtons + 12], df->dwObjSize);
-        This->buttons[i] = 0x80 | This->generic.devcaps.dwButtons;
+        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 12], df->dwObjSize);
         df->rgodf[idx  ].pguid = &GUID_Button;
-        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(This->generic.devcaps.dwButtons++) | DIDFT_PSHBUTTON;
+        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
     }
     df->dwNumObjs = idx;
+    This->generic.devcaps.dwButtons = This->joydev->button_count;
     This->generic.base.data_format.wine_df = df;
 
     fake_current_js_state(This);
@@ -746,8 +777,7 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
  * values on the axes
  */
 #define CENTER_AXIS(a) \
-    (ji->dev_axes_to_di[a] == -1 ? 0 : joystick_map_axis( &ji->generic.props[ji->dev_axes_to_di[a]], \
-                                                          ji->joydev->axes[a].value ))
+    (ji->joydev->dev_axes_to_di[a] == -1 ? 0 : joystick_map_axis(&ji->generic.props[ji->joydev->dev_axes_to_di[a]], ji->joydev->axes[a].value))
 static void fake_current_js_state(JoystickImpl *ji)
 {
     int i;
@@ -798,7 +828,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 	switch (ie.type) {
 	case EV_KEY:	/* button */
         {
-            int btn = This->buttons[ie.code];
+            int btn = This->joydev->buttons[ie.code];
 
             TRACE("(%p) %d -> %d\n", This, ie.code, btn);
             if (btn & 0x80)
@@ -811,7 +841,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         }
 	case EV_ABS:
         {
-            int axis = This->dev_axes_to_di[ie.code];
+            int axis = This->joydev->dev_axes_to_di[ie.code];
 
             /* User axis remapping */
             if (axis < 0) break;
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 2d25f50ebe2..fbde8fc5b3c 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -956,6 +956,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_init,
     NULL,
     NULL,
+    NULL,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
     NULL,
@@ -1155,10 +1156,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     get_osx_device_name(This->id, name, MAX_PATH);
     TRACE("Name %s\n",name);
 
-    /* copy the device name */
-    This->generic.name = HeapAlloc(GetProcessHeap(), 0, strlen(name) + 1);
-    strcpy(This->generic.name, name);
-
     list_init(&This->generic.ff_effects);
     if (get_ff(device, &This->ff) == S_OK)
     {
@@ -1295,7 +1292,6 @@ FAILED:
     if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
     HeapFree(GetProcessHeap(), 0, df);
     release_DataFormat(&This->generic.base.data_format);
-    HeapFree(GetProcessHeap(), 0, This->generic.name);
     return hr;
 }
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 8fe469edbc3..3c73bd9c41e 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -39,6 +39,8 @@ struct unix_joystick_vtbl
 {
     HRESULT (CDECL *init)(struct unix_joystick *ptr);
 
+    void (CDECL *get_mapping)(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
+
     HRESULT (CDECL *acquire)(struct unix_joystick *ptr);
     HRESULT (CDECL *unacquire)(struct unix_joystick *ptr);
 
@@ -63,8 +65,6 @@ typedef struct JoystickGenericImpl
     ObjProps    props[MAX_PROPS];
     DIDEVCAPS   devcaps;
     DIJOYSTATE2 js;     /* wine data */
-    char        *name;
-    int         device_axis_count;      /* Total number of axes in the device */
     int        *axis_map;               /* User axes remapping */
     LONG        deadzone;               /* Default dead-zone */
 
@@ -76,7 +76,6 @@ typedef struct JoystickGenericImpl
 extern HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out) DECLSPEC_HIDDEN;
 
 LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
-HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_map) DECLSPEC_HIDDEN;
 
 DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 
-- 
2.28.0

>From 8d5eed4a360dbf818652144c36c5a06401ead38b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 17:35:47 +0200
Subject: [PATCH 25/39] dinput: Use the unix vtable for initial reset.

---
 dlls/dinput/joystick.c            |  1 +
 dlls/dinput/joystick_linux.c      |  1 +
 dlls/dinput/joystick_linuxinput.c | 28 ++++++++++++++--------------
 dlls/dinput/joystick_osx.c        |  1 +
 dlls/dinput/joystick_private.h    |  1 +
 5 files changed, 18 insertions(+), 14 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index ec46b25c2cc..c9b683007d5 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1204,6 +1204,7 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
     }
 
     if (FAILED(hr = This->unix_funcs->init(This->unix_ptr))) goto done;
+    if (This->unix_funcs->reset) This->unix_funcs->reset(This->unix_ptr);
     if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
 
     TRACE("created unix joystick %p\n", This);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 48c1e4b433a..b6f52ded2e4 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -144,6 +144,7 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    NULL,
     unix_joystick_get_mapping,
     unix_joystick_acquire,
     unix_joystick_unacquire,
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 4206012e58e..87aa60b85e2 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -156,7 +156,6 @@ static inline JoystickImpl *impl_from_unix_joystick(struct unix_joystick *ptr)
     return (JoystickImpl *)ptr;
 }
 
-static void fake_current_js_state(JoystickImpl *ji);
 static void find_joydevs(void);
 static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 
@@ -174,11 +173,13 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
         struct list *entry, IDirectInputEffect **out);
 
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+static void CDECL unix_joystick_reset(struct unix_joystick *ptr);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    unix_joystick_reset,
     unix_joystick_get_mapping,
     unix_joystick_acquire,
     unix_joystick_unacquire,
@@ -647,8 +648,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     This->generic.devcaps.dwButtons = This->joydev->button_count;
     This->generic.base.data_format.wine_df = df;
 
-    fake_current_js_state(This);
-
     /* Fill the caps */
     This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
     This->generic.devcaps.dwFlags = DIDC_ATTACHED;
@@ -777,24 +776,25 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
  * values on the axes
  */
 #define CENTER_AXIS(a) \
-    (ji->joydev->dev_axes_to_di[a] == -1 ? 0 : joystick_map_axis(&ji->generic.props[ji->joydev->dev_axes_to_di[a]], ji->joydev->axes[a].value))
-static void fake_current_js_state(JoystickImpl *ji)
+    (This->joydev->dev_axes_to_di[a] == -1 ? 0 : joystick_map_axis(&This->generic.props[This->joydev->dev_axes_to_di[a]], This->joydev->axes[a].value))
+static void CDECL unix_joystick_reset(struct unix_joystick *ptr)
 {
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
     int i;
 
     /* center the axes */
-    ji->generic.js.lX           = CENTER_AXIS(ABS_X);
-    ji->generic.js.lY           = CENTER_AXIS(ABS_Y);
-    ji->generic.js.lZ           = CENTER_AXIS(ABS_Z);
-    ji->generic.js.lRx          = CENTER_AXIS(ABS_RX);
-    ji->generic.js.lRy          = CENTER_AXIS(ABS_RY);
-    ji->generic.js.lRz          = CENTER_AXIS(ABS_RZ);
-    ji->generic.js.rglSlider[0] = CENTER_AXIS(ABS_THROTTLE);
-    ji->generic.js.rglSlider[1] = CENTER_AXIS(ABS_RUDDER);
+    This->generic.js.lX           = CENTER_AXIS(ABS_X);
+    This->generic.js.lY           = CENTER_AXIS(ABS_Y);
+    This->generic.js.lZ           = CENTER_AXIS(ABS_Z);
+    This->generic.js.lRx          = CENTER_AXIS(ABS_RX);
+    This->generic.js.lRy          = CENTER_AXIS(ABS_RY);
+    This->generic.js.lRz          = CENTER_AXIS(ABS_RZ);
+    This->generic.js.rglSlider[0] = CENTER_AXIS(ABS_THROTTLE);
+    This->generic.js.rglSlider[1] = CENTER_AXIS(ABS_RUDDER);
 
     /* POV center is -1 */
     for (i = 0; i < 4; i++)
-        ji->generic.js.rgdwPOV[i] = -1;
+        This->generic.js.rgdwPOV[i] = -1;
 }
 #undef CENTER_AXIS
 
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index fbde8fc5b3c..a6c5512c767 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -957,6 +957,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     NULL,
     NULL,
+    NULL,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
     NULL,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 3c73bd9c41e..c2786bb4aeb 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -38,6 +38,7 @@ struct unix_joystick;
 struct unix_joystick_vtbl
 {
     HRESULT (CDECL *init)(struct unix_joystick *ptr);
+    void (CDECL *reset)(struct unix_joystick *ptr);
 
     void (CDECL *get_mapping)(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
-- 
2.28.0

>From 7ab59a47a623c0425cdc3a40ee81be7cd2077834 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 10:56:49 +0200
Subject: [PATCH 26/39] dinput: Pass props to unix joystick init.

---
 dlls/dinput/joystick.c            | 17 +++++++++++++++--
 dlls/dinput/joystick_linux.c      | 14 ++------------
 dlls/dinput/joystick_linuxinput.c | 24 ++++++++++++------------
 dlls/dinput/joystick_osx.c        | 17 ++++++-----------
 dlls/dinput/joystick_private.h    |  2 +-
 5 files changed, 36 insertions(+), 38 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index c9b683007d5..faefe593354 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1191,9 +1191,10 @@ static HRESULT setup_dinput_options(JoystickGenericImpl *This, int default_axis_
 HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out)
 {
     JoystickGenericImpl *This;
+    ObjProps props[MAX_PROPS];
     HRESULT hr;
     const int *default_axes_map;
-    int default_axis_count;
+    int i, default_axis_count;
 
     if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This)))
         return hr;
@@ -1203,7 +1204,19 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
         if (FAILED(hr = setup_dinput_options(This, default_axis_count, default_axes_map))) goto done;
     }
 
-    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr))) goto done;
+    for (i = 0; i < c_dfDIJoystick2.dwNumObjs; i++)
+    {
+        props[i].lDevMin = -32767;
+        props[i].lDevMax = +32767;
+        props[i].lMin = 0;
+        props[i].lMax = 0xffff;
+        props[i].lDeadZone = This->deadzone;
+        props[i].lSaturation = 0;
+    }
+
+    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props))) goto done;
+    memcpy(This->props, props, sizeof(This->props));
+
     if (This->unix_funcs->reset) This->unix_funcs->reset(This->unix_ptr);
     if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
 
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index b6f52ded2e4..166c8e85a2a 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -138,7 +138,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
@@ -508,7 +508,7 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     LPDIDATAFORMAT df = NULL;
@@ -554,16 +554,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     }
     This->generic.base.data_format.wine_df = df;
 
-    /* initialize default properties */
-    for (i = 0; i < c_dfDIJoystick2.dwNumObjs; i++) {
-        This->generic.props[i].lDevMin = -32767;
-        This->generic.props[i].lDevMax = +32767;
-        This->generic.props[i].lMin = 0;
-        This->generic.props[i].lMax = 0xffff;
-        This->generic.props[i].lDeadZone = This->generic.deadzone; /* % * 1000 */
-        This->generic.props[i].lSaturation = 0;
-    }
-
     This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
     This->generic.devcaps.dwFlags = DIDC_ATTACHED;
     This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 87aa60b85e2..0bf8f34dec5 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -172,7 +172,7 @@ static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, RE
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props);
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
@@ -560,7 +560,7 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     LPDIDATAFORMAT df = NULL;
@@ -584,8 +584,8 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     {
         if (idx < WINE_JOYSTICK_MAX_AXES && i < ABS_HAT0X && test_bit(This->joydev->absbits, i))
         {
-            This->generic.props[idx].lDevMin = This->joydev->axes[i].minimum;
-            This->generic.props[idx].lDevMax = This->joydev->axes[i].maximum;
+            props[idx].lDevMin = This->joydev->axes[i].minimum;
+            props[idx].lDevMax = This->joydev->axes[i].maximum;
             idx++;
         }
     }
@@ -594,10 +594,10 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     {
         if (test_bit(This->joydev->absbits, ABS_HAT0X + i * 2) && test_bit(This->joydev->absbits, ABS_HAT0Y + i * 2))
         {
-            This->generic.props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
-            This->generic.props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
-            This->generic.props[idx + 1].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
-            This->generic.props[idx + 1].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
+            props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
+            props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
+            props[idx + 1].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
+            props[idx + 1].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
             idx += 2;
         }
     }
@@ -627,10 +627,10 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
             i++; /* POV takes 2 axes */
         }
 
-        This->generic.props[idx].lMin = 0;
-        This->generic.props[idx].lMax = 0xffff;
-        This->generic.props[idx].lSaturation = 0;
-        This->generic.props[idx].lDeadZone = This->generic.deadzone;
+        props[idx].lMin = 0;
+        props[idx].lMax = 0xffff;
+        props[idx].lSaturation = 0;
+        props[idx].lDeadZone = This->generic.deadzone;
 
         /* Linux supports force-feedback on X & Y axes only */
         if (This->joydev->has_ff && (i == 0 || i == 1)) df->rgodf[idx].dwFlags |= DIDOI_FFACTUATOR;
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index a6c5512c767..0a1724181bc 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -108,7 +108,6 @@ struct JoystickImpl
     /* osx private */
     int                    id;
     CFArrayRef             elements;
-    ObjProps               **propmap;
     FFDeviceObjectReference ff;
 };
 
@@ -745,7 +744,7 @@ static void get_osx_device_elements(JoystickImpl *device, int axis_map[8])
     }
 }
 
-static void get_osx_device_elements_props(JoystickImpl *device)
+static void get_osx_device_elements_props(JoystickImpl *device, ObjProps *props)
 {
     TRACE("device %p\n", device);
 
@@ -759,12 +758,8 @@ static void get_osx_device_elements_props(JoystickImpl *device)
 
             TRACE("element %s\n", debugstr_element(element));
 
-            device->generic.props[idx].lDevMin = IOHIDElementGetLogicalMin(element);
-            device->generic.props[idx].lDevMax = IOHIDElementGetLogicalMax(element);
-            device->generic.props[idx].lMin =  0;
-            device->generic.props[idx].lMax =  0xffff;
-            device->generic.props[idx].lDeadZone = 0;
-            device->generic.props[idx].lSaturation = 0;
+            props[idx].lDevMin = IOHIDElementGetLogicalMin(element);
+            props[idx].lDevMax = IOHIDElementGetLogicalMax(element);
         }
     }
 }
@@ -949,7 +944,7 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
         struct list *entry, IDirectInputEffect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
@@ -1138,7 +1133,7 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
     return DI_OK;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     IOHIDDeviceRef device;
@@ -1268,7 +1263,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
     This->generic.base.data_format.wine_df = df;
 
     /* initialize default properties */
-    get_osx_device_elements_props(This);
+    get_osx_device_elements_props(This, props);
 
     This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
     This->generic.devcaps.dwFlags |= DIDC_ATTACHED;
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index c2786bb4aeb..536b77b3ea2 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -37,7 +37,7 @@ struct unix_joystick;
 
 struct unix_joystick_vtbl
 {
-    HRESULT (CDECL *init)(struct unix_joystick *ptr);
+    HRESULT (CDECL *init)(struct unix_joystick *ptr, ObjProps *props);
     void (CDECL *reset)(struct unix_joystick *ptr);
 
     void (CDECL *get_mapping)(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
-- 
2.28.0

>From 91eb088e55ac2a72f55bc34557218afefdd4206e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 09:55:08 +0200
Subject: [PATCH 27/39] dinput: Fill and access props consistently.

The prop index is the dinput axis index, regardless of user remapping.
---
 dlls/dinput/device.c              |  2 +-
 dlls/dinput/device_private.h      |  1 -
 dlls/dinput/joystick_linux.c      |  2 +-
 dlls/dinput/joystick_linuxinput.c | 21 +++++++++------------
 4 files changed, 11 insertions(+), 15 deletions(-)

diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index af05fdf14f0..9f3e5af836e 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -587,7 +587,7 @@ static int offset_to_object(const DataFormat *df, int offset)
     return -1;
 }
 
-int id_to_object(LPCDIDATAFORMAT df, int id)
+static int id_to_object(LPCDIDATAFORMAT df, int id)
 {
     int i;
 
diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index 52a7b3c3dc7..3cc6eeecb91 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -103,7 +103,6 @@ extern void fill_DataFormat(void *out, DWORD size, const void *in, const DataFor
 extern void release_DataFormat(DataFormat *df)  DECLSPEC_HIDDEN;
 extern void queue_event(IDirectInputDevice8W *iface, int inst_id, DWORD data, DWORD time, DWORD seq) DECLSPEC_HIDDEN;
 /* Helper functions to work with data format */
-extern int id_to_object(LPCDIDATAFORMAT df, int id) DECLSPEC_HIDDEN;
 extern int find_property(const DataFormat *df, LPCDIPROPHEADER ph) DECLSPEC_HIDDEN;
 
 /* Common joystick stuff */
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 166c8e85a2a..b4b7b36bce6 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -673,7 +673,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
             if (number < 0) return;
             inst_id = number < 8 ?  DIDFT_MAKEINSTANCE(number) | DIDFT_ABSAXIS :
                                     DIDFT_MAKEINSTANCE(number - 8) | DIDFT_POV;
-            value = joystick_map_axis(&This->generic.props[id_to_object(This->generic.base.data_format.wine_df, inst_id)], jse.value);
+            value = joystick_map_axis(&This->generic.props[This->joydev->axes_map[jse.number]], jse.value);
 
             TRACE("changing axis %d => %d\n", jse.number, number);
             switch (number)
